package sample;

import java.io.File;
import java.util.ArrayList;

/**
 * Created by Patrick on 12.09.2016.
 */
public class Table {
    public ArrayList<ArrayList<Integer>> cols;
    public Table(File file){
        cols=new ArrayList<>();
        ArrayList<String> fileContent=FileHandling.readFileToArray(file);
        for(int i=0;i<fileContent.size();i++) {
            String line=fileContent.get(i);
            String[] arLine=line.split(Main.delimeter);
            for(int j=0;j<arLine.length;j++)
                try {
                    addColValue(j, Integer.parseInt(arLine[j]));
                }catch (NumberFormatException e){}
        }
    }
    public void addColValue(int col, int value){
        while(cols.size()<=col)
            cols.add(new ArrayList<>());
        cols.get(col).add(value);
    }
    public ArrayList<ArrayList<ArrayList<Integer>>> searchTable(Controller controller,int numbersBefore,int numbersBehind,int[] searchNumbers){
        ArrayList<ArrayList<ArrayList<Integer>>> items=new ArrayList<>();
        for(int i=0;i<cols.size();i++){
            ArrayList<ArrayList<Integer>> tmp=new ArrayList<>();
            ArrayList<Integer> col=cols.get(i);
            for(int j=numbersBefore;j<col.size()-numbersBehind-1;j++){
                if((j%100)==0)
                    controller.setStatus("Durchsuche Spalte "+(i+1)+" Zeile "+j+"+");
                if(col.get(j)==searchNumbers[0] && j+(searchNumbers.length-1)<col.size()-numbersBehind) {
                    boolean notFound=false;
                    for (int k = 0; k < searchNumbers.length; k++) {
                        if (!(col.get(j + k) == searchNumbers[k])) {
                            notFound = true;
                            break;
                        }
                    }
                    if(!notFound){
                        ArrayList<Integer> tmp2=new ArrayList<>();
                        for(int k=j-numbersBefore;k<j+searchNumbers.length+numbersBehind;k++)
                            tmp2.add(col.get(k));
                        tmp.add(tmp2);
                    }
                }
            }
            items.add(tmp);
        }
        return items;
    }
}
